From 0956fb347f28342bc1022f8b26c68dcff697149d Mon Sep 17 00:00:00 2001
From: Jonathan Hsieh <jon@cloudera.com>
Date: Sat, 16 Apr 2011 10:57:43 -0700
Subject: [PATCH] FLUME-603: Revisit Performance tests
 - Remove dependencies on non-existing data sets.
 - Remove reporting tests (not relevent/supported)
 - add some accounting to avro sink to present proper MB/s statistitcs on batched datasets

---
 .../flume/handlers/avro/AvroEventSink.java         |   21 +-
 .../flume/handlers/thrift/ThriftEventSink.java     |    5 +-
 src/java/com/cloudera/util/Benchmark.java          |    6 +
 .../apache/apache/ipc/AccountingTransceiver.java   |   79 ++++++
 .../com/cloudera/flume/ExamplePerfData.java        |   30 --
 .../com/cloudera/flume/FlumeBenchmarkHarness.java  |  163 +++++++++++
 src/javaperf/com/cloudera/flume/PerfAvroSinks.java |  296 ++++++++++++++++++++
 src/javaperf/com/cloudera/flume/PerfDiskIO.java    |   27 +--
 .../com/cloudera/flume/PerfGrepReportSinks.java    |   76 -----
 src/javaperf/com/cloudera/flume/PerfHdfsIO.java    |   17 +-
 .../com/cloudera/flume/PerfReportSinks.java        |   74 +-----
 src/javaperf/com/cloudera/flume/PerfSamplers.java  |   22 +--
 .../com/cloudera/flume/PerfSyslogFormats.java      |   86 ------
 .../com/cloudera/flume/PerfThriftSinks.java        |  146 ++++++++---
 .../com/cloudera/flume/TestSynthSources.java       |  143 ++++++++++
 .../cloudera/flume/agent/BenchmarkAgentDecos.java  |   38 ++--
 .../cloudera/flume/agent/BenchmarkBasicDecos.java  |    8 +-
 .../agent/diskfailover/TestConcurrentDFOMan.java   |    6 +-
 .../diskfailover/TestDiskFailoverBehavior.java     |    6 +-
 .../diskfailover/TestDiskFailoverBenchmarking.java |   18 +-
 .../agent/diskfailover/TestDiskFailoverDeco.java   |    6 +-
 .../diskfailover/TestDiskFailoverManager.java      |    8 +-
 .../agent/durability/TestConcurrentWALMan.java     |    6 +-
 .../agent/durability/TestNaiveFileWALDeco.java     |   38 ++--
 .../agent/durability/TestNaiveFileWALHandles.java  |    6 +-
 .../agent/durability/TestNaiveFileWALManager.java  |   32 +-
 .../flume/collector/TestCollectorSink.java         |   14 +-
 .../flume/handlers/avro/TestAvroSinks.java         |    4 +-
 .../flume/handlers/debug/TestSynthSources.java     |  140 ---------
 .../flume/handlers/rolling/TestRollRollTags.java   |   10 +-
 .../com/cloudera/util/BenchmarkHarness.java        |  246 ----------------
 .../com/cloudera/util/FlumeTestHarness.java        |  112 ++++++++
 32 files changed, 1042 insertions(+), 847 deletions(-)
 create mode 100644 src/java/org/apache/apache/ipc/AccountingTransceiver.java
 delete mode 100644 src/javaperf/com/cloudera/flume/ExamplePerfData.java
 create mode 100644 src/javaperf/com/cloudera/flume/FlumeBenchmarkHarness.java
 create mode 100644 src/javaperf/com/cloudera/flume/PerfAvroSinks.java
 delete mode 100644 src/javaperf/com/cloudera/flume/PerfGrepReportSinks.java
 delete mode 100644 src/javaperf/com/cloudera/flume/PerfSyslogFormats.java
 create mode 100644 src/javaperf/com/cloudera/flume/TestSynthSources.java
 delete mode 100644 src/javatest/com/cloudera/flume/handlers/debug/TestSynthSources.java
 delete mode 100644 src/javatest/com/cloudera/util/BenchmarkHarness.java
 create mode 100644 src/javatest/com/cloudera/util/FlumeTestHarness.java

diff --git a/src/java/com/cloudera/flume/handlers/avro/AvroEventSink.java b/src/java/com/cloudera/flume/handlers/avro/AvroEventSink.java
index e5e5dc2..5b6ed9e 100644
--- a/src/java/com/cloudera/flume/handlers/avro/AvroEventSink.java
+++ b/src/java/com/cloudera/flume/handlers/avro/AvroEventSink.java
@@ -19,10 +19,11 @@ package com.cloudera.flume.handlers.avro;
 
 import java.io.IOException;
 import java.net.URL;
-import java.util.concurrent.atomic.AtomicLong;
 
+import org.apache.apache.ipc.AccountingTransceiver;
 import org.apache.avro.AvroRemoteException;
 import org.apache.avro.ipc.HttpTransceiver;
+import org.apache.avro.ipc.Transceiver;
 import org.apache.avro.ipc.specific.SpecificRequestor;
 import org.slf4j.Logger;
 import org.slf4j.LoggerFactory;
@@ -35,7 +36,7 @@ import com.cloudera.flume.core.EventSink;
 import com.cloudera.flume.reporter.ReportEvent;
 
 /**
- *This is a sink that sends events to a remote host/port using Avro.
+ * This is a sink that sends events to a remote host/port using Avro.
  */
 public class AvroEventSink extends EventSink.Base {
 
@@ -48,15 +49,17 @@ public class AvroEventSink extends EventSink.Base {
   protected FlumeEventAvroServer avroClient;
   String host;
   int port;
-  HttpTransceiver transport;
+  Transceiver http;
+  AccountingTransceiver transport;
 
   // this boolean variable is not used anywhere
   boolean nonblocking;
+
   /*
    * The following variables keeps track of the number of bytes of the
    * Event.body shipped.
    */
-  AtomicLong sentBytes = new AtomicLong();
+  // AtomicLong sentBytes = new AtomicLong();
 
   public AvroEventSink(String host, int port) {
     this.host = host;
@@ -74,7 +77,6 @@ public class AvroEventSink extends EventSink.Base {
     this.ensureInitialized();
     try {
       avroClient.append(afe);
-      sentBytes.addAndGet(e.getBody().length);
       super.append(e);
     } catch (AvroRemoteException e1) {
       throw new IOException("Append failed " + e1.getMessage(), e1);
@@ -94,7 +96,8 @@ public class AvroEventSink extends EventSink.Base {
   public void open() throws IOException {
 
     URL url = new URL("http", host, port, "/");
-    transport = new HttpTransceiver(url);
+    http = new HttpTransceiver(url);
+    transport = new AccountingTransceiver(http);
     try {
       this.avroClient = (FlumeEventAvroServer) SpecificRequestor.getClient(
           FlumeEventAvroServer.class, transport);
@@ -119,6 +122,10 @@ public class AvroEventSink extends EventSink.Base {
     }
   }
 
+  public long getSentBytes() {
+    return transport.getSentBytes();
+  }
+
   /**
    * {@inheritDoc}
    */
@@ -127,7 +134,7 @@ public class AvroEventSink extends EventSink.Base {
     ReportEvent rpt = super.getMetrics();
     rpt.setStringMetric(A_SERVERHOST, host);
     rpt.setLongMetric(A_SERVERPORT, port);
-    rpt.setLongMetric(A_SENTBYTES, sentBytes.get());
+    rpt.setLongMetric(A_SENTBYTES, transport.getSentBytes());
     return rpt;
   }
 
diff --git a/src/java/com/cloudera/flume/handlers/thrift/ThriftEventSink.java b/src/java/com/cloudera/flume/handlers/thrift/ThriftEventSink.java
index 81dc71d..8e89456 100644
--- a/src/java/com/cloudera/flume/handlers/thrift/ThriftEventSink.java
+++ b/src/java/com/cloudera/flume/handlers/thrift/ThriftEventSink.java
@@ -34,7 +34,6 @@ import com.cloudera.flume.conf.Context;
 import com.cloudera.flume.conf.FlumeConfiguration;
 import com.cloudera.flume.conf.SinkFactory.SinkBuilder;
 import com.cloudera.flume.core.Event;
-import com.cloudera.flume.core.EventImpl;
 import com.cloudera.flume.core.EventSink;
 import com.cloudera.flume.handlers.thrift.ThriftFlumeEventServer.Client;
 import com.cloudera.flume.reporter.ReportEvent;
@@ -116,6 +115,10 @@ public class ThriftEventSink extends EventSink.Base {
           + port + " : " + e.getMessage());
     }
   }
+  
+  public long getSentBytes() {
+    return sentBytes.get();
+  }
 
   @Override
   public ReportEvent getMetrics() {
diff --git a/src/java/com/cloudera/util/Benchmark.java b/src/java/com/cloudera/util/Benchmark.java
index de0e290..8921c01 100644
--- a/src/java/com/cloudera/util/Benchmark.java
+++ b/src/java/com/cloudera/util/Benchmark.java
@@ -40,6 +40,7 @@ import com.google.common.base.Preconditions;
 public class Benchmark {
   long start;
   long last;
+  long lastDelta;
   PrintWriter out;
   PrintWriter log;
   List<String> values = new ArrayList<String>();
@@ -125,6 +126,7 @@ public class Benchmark {
 
     // skip over gc time
     last = System.nanoTime(); // don't count gc time.
+    lastDelta = delta;
   }
 
   /**
@@ -143,6 +145,10 @@ public class Benchmark {
     return log;
   }
 
+  public long getLastDelta() {
+    return lastDelta;
+  }
+
   /**
    * In case I want to print the csv report summary
    * 
diff --git a/src/java/org/apache/apache/ipc/AccountingTransceiver.java b/src/java/org/apache/apache/ipc/AccountingTransceiver.java
new file mode 100644
index 0000000..c8557b1
--- /dev/null
+++ b/src/java/org/apache/apache/ipc/AccountingTransceiver.java
@@ -0,0 +1,79 @@
+package org.apache.apache.ipc;
+
+import java.io.IOException;
+import java.nio.ByteBuffer;
+import java.util.List;
+import java.util.concurrent.atomic.AtomicLong;
+
+import org.apache.avro.Protocol;
+import org.apache.avro.ipc.Transceiver;
+
+public class AccountingTransceiver extends Transceiver {
+  Transceiver xcvr;
+
+  AtomicLong bytesWritten = new AtomicLong();
+
+  public AccountingTransceiver(Transceiver xcvr) {
+    this.xcvr = xcvr;
+  }
+
+  @Override
+  public String getRemoteName() {
+    return xcvr.getRemoteName();
+  }
+
+  // Transceive is explicitly excluded because it calls readBuffers and
+  // writeBuffers virtual funcs.
+
+  @Override
+  public List<ByteBuffer> readBuffers() throws IOException {
+    return xcvr.readBuffers();
+  }
+
+  @Override
+  public void writeBuffers(List<ByteBuffer> arg0) throws IOException {
+    long len = getLength(arg0); // must be done before writing them.
+    xcvr.writeBuffers(arg0);
+    bytesWritten.addAndGet(len);
+  }
+
+  @Override
+  public boolean isConnected() {
+    return xcvr.isConnected();
+  }
+
+  @Override
+  public void setRemote(Protocol protocol) {
+    xcvr.setRemote(protocol);
+  }
+
+  @Override
+  public Protocol getRemote() {
+    return xcvr.getRemote();
+  }
+
+  @Override
+  public void close() throws IOException {
+    xcvr.close();
+  }
+
+  public long getSentBytes() {
+    return bytesWritten.get();
+  }
+
+  static int getLength(List<ByteBuffer> buffers) {
+    int length = 0;
+    for (ByteBuffer buffer : buffers) {
+      length += 4;
+      length += buffer.remaining();
+    }
+    length += 4;
+    return length;
+  }
+
+  static long bufferLens(List<ByteBuffer> buffers) throws IOException {
+    long len = getLength(buffers);
+    return len + 4;
+  }
+
+}
diff --git a/src/javaperf/com/cloudera/flume/FlumeBenchmarkHarness.java b/src/javaperf/com/cloudera/flume/FlumeBenchmarkHarness.java
new file mode 100644
index 0000000..d946ab2
--- /dev/null
+++ b/src/javaperf/com/cloudera/flume/FlumeBenchmarkHarness.java
@@ -0,0 +1,163 @@
+package com.cloudera.flume;
+
+import java.io.IOException;
+import java.util.Date;
+import java.util.HashMap;
+import java.util.Map;
+import java.util.SortedMap;
+import java.util.TreeMap;
+
+import com.cloudera.flume.conf.Context;
+import com.cloudera.flume.conf.FlumeBuilder;
+import com.cloudera.flume.conf.FlumeSpecException;
+import com.cloudera.flume.core.Attributes;
+import com.cloudera.flume.core.EventSink;
+import com.cloudera.flume.core.EventSource;
+import com.cloudera.flume.core.EventUtil;
+import com.cloudera.flume.handlers.debug.AttrSynthSource;
+import com.cloudera.flume.handlers.debug.BenchmarkReportDecorator;
+import com.cloudera.flume.handlers.debug.MemorySinkSource;
+import com.cloudera.flume.handlers.debug.NoNlASCIISynthSource;
+import com.cloudera.flume.reporter.ReportEvent;
+import com.cloudera.flume.reporter.ReportManager;
+import com.cloudera.flume.reporter.Reportable;
+import com.cloudera.util.FlumeTestHarness;
+
+public class FlumeBenchmarkHarness extends FlumeTestHarness {
+  // This is a tiny test set, suitable for step-through debugging
+  @SuppressWarnings("serial")
+  public static Map<String, EventSource> tiny = new HashMap<String, EventSource>() {
+    {
+      // datasets with fields, x attributes, 10 byte long attr names, 10
+      // byte
+      // values.
+      put("10,10,5,5,8", new AttrSynthSource(10, 5, 5, 8, 1337));
+    }
+  };
+
+  // This is a data set that varies the size of the body of an event.
+  @SuppressWarnings("serial")
+  public static Map<String, EventSource> varyMsgBytes = new HashMap<String, EventSource>() {
+    {
+      // 1337 is the rand seed.
+
+      // this is *really* slow
+      put("100000,10,0,0,0", new NoNlASCIISynthSource(100000, 10, 1337));
+      put("100000,100,0,0,0", new NoNlASCIISynthSource(100000, 100, 1337));
+      put("100000,1000,0,0,0", new NoNlASCIISynthSource(100000, 1000, 1337));
+      put("100000,3000,0,0,0", new NoNlASCIISynthSource(100000, 3000, 1337));
+      put("100000,10000,0,0,0", new NoNlASCIISynthSource(100000, 10000, 1337));
+    }
+  };
+
+  // This dataset varies the # of attributes an event has. The latter two
+  // entries send fewer messages because the size of the messages are memory
+  // prohibitive
+  @SuppressWarnings("serial")
+  public static Map<String, EventSource> varyNumAttrs = new HashMap<String, EventSource>() {
+    {
+      // datasets with fields, x attributes, 10 byte long attr names, 10
+      // byte
+      // values.
+      put("100000,0,10,10,10", new AttrSynthSource(100000, 10, 10, 10, 1337));
+      put("100000,0,100,10,10", new AttrSynthSource(100000, 100, 10, 10, 1337));
+      put("10000,0,1000,10,10", new AttrSynthSource(10000, 1000, 10, 10, 1337));
+      put("1000,0,10000,10,10", new AttrSynthSource(1000, 10000, 10, 10, 1337));
+    }
+  };
+
+  // This dataset varies the size of the values associated with an attribute.
+  @SuppressWarnings("serial")
+  public static Map<String, EventSource> varyValSize = new HashMap<String, EventSource>() {
+    {
+      // datasets with fields, 10 attributes, 10 byte long attr names, xx
+      // byte
+      // values.
+      put("100000,0,10,10,10", new AttrSynthSource(100000, 10, 10, 10, 1337));
+      put("100000,0,10,10,100", new AttrSynthSource(100000, 10, 10, 100, 1337));
+      put("100000,0,10,10,1000",
+          new AttrSynthSource(100000, 10, 10, 1000, 1337));
+      put("1000,0,10,10,10000", new AttrSynthSource(10000, 10, 10, 10000, 1337));
+    }
+  };
+
+  /**
+   * This takes what ever data set comes in and multiplies it by 10x volume.
+   */
+  public static EventSink createDecoratorBenchmarkSink(String name, String deco)
+      throws FlumeSpecException {
+    String spec = "mult(10) benchinject " + deco + " benchreport(\"" + name
+        + "\") null";
+    return FlumeBuilder.buildSink(new Context(), spec);
+  }
+
+  public static EventSink createSinkBenchmark(String name, String sink)
+      throws FlumeSpecException {
+    String spec = "benchinject benchreport(\"" + name + "\") " + sink;
+    return FlumeBuilder.buildSink(new Context(), spec);
+  }
+
+  /**
+   * This takes a single decorator, and then applies all of the datasets through
+   * the decorator. Each source is bufferzied -- the given number of messages
+   * are stored in memory so that they can be blasted through any deco.
+   * 
+   * @throws InterruptedException
+   */
+  public static void doDecoBenchmark(String deco, Map<String, EventSource> sets)
+      throws FlumeSpecException, IOException, InterruptedException {
+    for (Map.Entry<String, EventSource> ent : sets.entrySet()) {
+      setupLocalWriteDir();
+      ReportManager.get().clear();
+
+      // copy all events into memory
+      EventSource src = MemorySinkSource.bufferize(ent.getValue());
+      EventSink snk = createDecoratorBenchmarkSink(ent.getKey() + "," + deco,
+          deco);
+      src.open();
+      snk.open();
+      EventUtil.dumpAll(src, snk);
+      src.close();
+      snk.close();
+      dumpReports();
+      cleanupLocalWriteDir();
+    }
+  }
+
+  /**
+   * This gets reports and outputs them to std err in csv format.
+   */
+  public static void dumpReports() {
+    ReportManager rman = ReportManager.get();
+    SortedMap<String, Reportable> sorted = new TreeMap<String, Reportable>(
+        rman.getReportables());
+    for (Map.Entry<String, Reportable> ent : sorted.entrySet()) {
+      String params = ent.getKey();
+      ReportEvent r = ent.getValue().getMetrics();
+      System.out.println(new String(r.toString()));
+      System.err.print(new Date(r.getTimestamp()) + ",");
+      System.err.print(params + ",");
+      System.err.print(Attributes.readString(r,
+          BenchmarkReportDecorator.A_BENCHMARK_CSV));
+    }
+  }
+
+  /**
+   * This is about 300MB in memory
+   */
+  public static MemorySinkSource synthInMem() throws IOException,
+      InterruptedException {
+    return synthInMem(1000000, 100, 1);
+  }
+
+  public static MemorySinkSource synthInMem(int count, int bodySz, int seed)
+      throws IOException, InterruptedException {
+    EventSource txt = new NoNlASCIISynthSource(count, bodySz, seed);
+    txt.open();
+    MemorySinkSource mem = new MemorySinkSource();
+    mem.open();
+    EventUtil.dumpAll(txt, mem);
+    txt.close();
+    return mem;
+  }
+}
diff --git a/src/javaperf/com/cloudera/flume/PerfAvroSinks.java b/src/javaperf/com/cloudera/flume/PerfAvroSinks.java
new file mode 100644
index 0000000..19dc950
--- /dev/null
+++ b/src/javaperf/com/cloudera/flume/PerfAvroSinks.java
@@ -0,0 +1,296 @@
+/**
+ * Licensed to Cloudera, Inc. under one
+ * or more contributor license agreements.  See the NOTICE file
+ * distributed with this work for additional information
+ * regarding copyright ownership.  Cloudera, Inc. licenses this file
+ * to you under the Apache License, Version 2.0 (the
+ * "License"); you may not use this file except in compliance
+ * with the License.  You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+package com.cloudera.flume;
+
+import java.io.IOException;
+
+import org.junit.Test;
+
+import com.cloudera.flume.conf.FlumeConfiguration;
+import com.cloudera.flume.core.EventUtil;
+import com.cloudera.flume.handlers.avro.AvroEventSink;
+import com.cloudera.flume.handlers.avro.AvroEventSource;
+import com.cloudera.flume.handlers.batch.BatchingDecorator;
+import com.cloudera.flume.handlers.debug.MemorySinkSource;
+import com.cloudera.flume.handlers.debug.NullSink;
+import com.cloudera.util.Benchmark;
+
+/**
+ * These tests are for microbenchmarking the Avro sink and server elements.
+ */
+public class PerfAvroSinks {
+
+  /**
+   * mem -> AvroEventSink -> AvroEventSource -> NullSink
+   */
+  @Test
+  public void testAvroSend() throws IOException, InterruptedException {
+
+    Benchmark b = new Benchmark("nullsink");
+    b.mark("begin");
+    MemorySinkSource mem = FlumeBenchmarkHarness.synthInMem();
+    b.mark("disk_loaded");
+
+    FlumeConfiguration conf = FlumeConfiguration.get();
+    final AvroEventSource tes = new AvroEventSource(conf.getCollectorPort());
+    tes.open();
+    // need to drain the sink otherwise its queue will fill up with events!
+    Thread drain = new Thread("drain") {
+      public void run() {
+        try {
+          EventUtil.dumpAll(tes, new NullSink());
+        } catch (Exception e) {
+          // TODO Auto-generated catch block
+          e.printStackTrace();
+        }
+      }
+    };
+    drain.start(); // drain the sink.
+    b.mark("receiver_started");
+
+    final AvroEventSink snk = new AvroEventSink("0.0.0.0",
+        conf.getCollectorPort());
+    snk.open();
+    b.mark("sink_started");
+
+    EventUtil.dumpAll(mem, snk);
+    b.mark("Avro sink to Avro source done");
+    // MB/s = B/us
+    b.mark("MB/s", (double) snk.getSentBytes()
+        / (double) (b.getLastDelta() / 1000));
+    tes.close();
+    snk.close();
+    drain.interrupt();
+    b.done();
+  }
+
+  /**
+   * mem -> batch(10) AvroEventSink -> AvroEventSource -> NullSink
+   */
+  @Test
+  public void testAvroBatchSend10() throws IOException, InterruptedException {
+
+    Benchmark b = new Benchmark("nullsink");
+    b.mark("begin");
+    MemorySinkSource mem = FlumeBenchmarkHarness.synthInMem();
+    b.mark("disk_loaded");
+
+    FlumeConfiguration conf = FlumeConfiguration.get();
+    final AvroEventSource tes = new AvroEventSource(conf.getCollectorPort());
+    tes.open();
+    // need to drain the sink otherwise its queue will fill up with events!
+    Thread drain = new Thread("drain") {
+      public void run() {
+        try {
+          EventUtil.dumpAll(tes, new NullSink());
+        } catch (Exception e) {
+          // TODO Auto-generated catch block
+          e.printStackTrace();
+        }
+      }
+    };
+    drain.start(); // drain the sink.
+    b.mark("receiver_started");
+
+    final AvroEventSink tsnk = new AvroEventSink("0.0.0.0",
+        conf.getCollectorPort());
+    // make size happen first all the time.
+    final BatchingDecorator snk = new BatchingDecorator(tsnk, 10, 10000000);
+    snk.open();
+    b.mark("sink_started");
+
+    EventUtil.dumpAll(mem, snk);
+    b.mark("Avro sink to Avro source done");
+    // MB/s = B/us
+    b.mark("MB/s", (double) tsnk.getSentBytes()
+        / (double) (b.getLastDelta() / 1000));
+
+    tes.close();
+    snk.close();
+    drain.interrupt();
+    b.done();
+  }
+
+  /**
+   * mem -> batch(10) AvroEventSink -> AvroEventSource -> NullSink
+   */
+  @Test
+  public void testAvroBatchSend100() throws IOException, InterruptedException {
+
+    Benchmark b = new Benchmark("nullsink");
+    b.mark("begin");
+    MemorySinkSource mem = FlumeBenchmarkHarness.synthInMem();
+    b.mark("disk_loaded");
+
+    FlumeConfiguration conf = FlumeConfiguration.get();
+    final AvroEventSource tes = new AvroEventSource(conf.getCollectorPort());
+    tes.open();
+    // need to drain the sink otherwise its queue will fill up with events!
+    Thread drain = new Thread("drain") {
+      public void run() {
+        try {
+          EventUtil.dumpAll(tes, new NullSink());
+        } catch (Exception e) {
+          // TODO Auto-generated catch block
+          e.printStackTrace();
+        }
+      }
+    };
+    drain.start(); // drain the sink.
+    b.mark("receiver_started");
+
+    final AvroEventSink tsnk = new AvroEventSink("0.0.0.0",
+        conf.getCollectorPort());
+    // make size happen first all the time.
+    final BatchingDecorator snk = new BatchingDecorator(tsnk, 100, 10000000);
+    snk.open();
+    b.mark("sink_started");
+
+    EventUtil.dumpAll(mem, snk);
+    b.mark("Avro sink to Avro source done");
+    // MB/s = B/us
+    b.mark("MB/s", (double) tsnk.getSentBytes()
+        / (double) (b.getLastDelta() / 1000));
+
+    tes.close();
+    snk.close();
+    drain.interrupt();
+    b.done();
+  }
+  
+  /**
+   * This is slighlty different by using another thread to kick off the sink. It
+   * shouldn't really matter much.
+   * 
+   * Pipeline is:
+   * 
+   * text -> mem
+   * 
+   * mem -> AvroEventSink -> AvroEventSource -> NullSink
+   **/
+  @Test
+  public void testAvroSendMulti() throws IOException, InterruptedException {
+
+    Benchmark b = new Benchmark("nullsink");
+    b.mark("begin");
+
+    MemorySinkSource mem = FlumeBenchmarkHarness.synthInMem();
+    b.mark("disk_loaded");
+
+    FlumeConfiguration conf = FlumeConfiguration.get();
+    final AvroEventSource tes = new AvroEventSource(conf.getCollectorPort());
+    tes.open();
+    // need to drain the sink otherwise its queue will fill up with events!
+    Thread drain = new Thread("drain") {
+      public void run() {
+        try {
+          EventUtil.dumpAll(tes, new NullSink());
+        } catch (Exception e) {
+          // TODO Auto-generated catch block
+          e.printStackTrace();
+        }
+      }
+    };
+    drain.start(); // drain the sink.
+    b.mark("receiver_started");
+
+    final AvroEventSink snk = new AvroEventSink("0.0.0.0",
+        conf.getCollectorPort());
+
+    Thread t = new Thread() {
+      public void run() {
+        try {
+          snk.open();
+        } catch (IOException e) {
+          // TODO Auto-generated catch block
+          e.printStackTrace();
+        }
+      }
+    };
+    t.start();
+    b.mark("sink_started");
+
+    EventUtil.dumpAll(mem, snk);
+    b.mark("Avro sink to Avro source done");
+    // MB/s = B/us
+    b.mark("MB/s", (double) snk.getSentBytes()
+        / (double) (b.getLastDelta() / 1000));
+
+    Thread.sleep(1000);
+    tes.close();
+    snk.close();
+    t.interrupt();
+    drain.interrupt();
+    b.done();
+  }
+
+  /**
+   * Here we are using the AvroRawEventSink instead of the AvroEventSink
+   * 
+   * Pipeline is:
+   * 
+   * text -> mem
+   * 
+   * mem -> AvroRawEventSink -> AvroEventSource -> NullSink
+   * 
+   * @throws InterruptedException
+   */
+  @Test
+  public void testAvroRawSend() throws IOException, InterruptedException {
+
+    Benchmark b = new Benchmark("nullsink");
+    b.mark("begin");
+
+    MemorySinkSource mem = FlumeBenchmarkHarness.synthInMem();
+    b.mark("disk_loaded");
+
+    FlumeConfiguration conf = FlumeConfiguration.get();
+    final AvroEventSource tes = new AvroEventSource(conf.getCollectorPort());
+    tes.open();
+    // need to drain the sink otherwise its queue will fill up with events!
+    Thread drain = new Thread("drain") {
+      public void run() {
+        try {
+          EventUtil.dumpAll(tes, new NullSink());
+        } catch (Exception e) {
+          // TODO Auto-generated catch block
+          e.printStackTrace();
+        }
+      }
+    };
+    drain.start(); // drain the sink.
+    b.mark("receiver_started");
+
+    final AvroEventSink snk = new AvroEventSink("0.0.0.0",
+        conf.getCollectorPort());
+    snk.open();
+    b.mark("sink_started");
+
+    EventUtil.dumpAll(mem, snk);
+    b.mark("Avro sink to Avro source done");
+    // MB/s = B/us
+    b.mark("MB/s", (double) snk.getSentBytes()
+        / (double) (b.getLastDelta() / 1000));
+
+    tes.close();
+    snk.close();
+    drain.interrupt();
+    b.done();
+  }
+
+}
diff --git a/src/javaperf/com/cloudera/flume/PerfDiskIO.java b/src/javaperf/com/cloudera/flume/PerfDiskIO.java
index f52bc65..93f32e6 100644
--- a/src/javaperf/com/cloudera/flume/PerfDiskIO.java
+++ b/src/javaperf/com/cloudera/flume/PerfDiskIO.java
@@ -23,9 +23,7 @@ import java.io.IOException;
 import org.junit.Test;
 
 import com.cloudera.flume.core.EventUtil;
-import com.cloudera.flume.handlers.debug.Log4jTextFileSource;
 import com.cloudera.flume.handlers.debug.MemorySinkSource;
-import com.cloudera.flume.handlers.debug.TextFileSource;
 import com.cloudera.flume.handlers.hdfs.SeqfileEventSink;
 import com.cloudera.flume.handlers.hdfs.SeqfileEventSource;
 import com.cloudera.util.Benchmark;
@@ -34,19 +32,13 @@ import com.cloudera.util.Benchmark;
  * This performance test tests the throughput of various disk reading and
  * writing sources and sinks.
  */
-public class PerfDiskIO implements ExamplePerfData {
+public class PerfDiskIO {
 
   @Test
   public void testWrite() throws IOException, InterruptedException {
     Benchmark b = new Benchmark("seqfile write");
     b.mark("begin");
-
-    TextFileSource txt = new TextFileSource(HADOOP_DATA[0]);
-    txt.open();
-    MemorySinkSource mem = new MemorySinkSource();
-    mem.open();
-    EventUtil.dumpAll(txt, mem);
-    txt.close();
+    MemorySinkSource mem = FlumeBenchmarkHarness.synthInMem();
     b.mark("disk_loaded");
 
     File tmp = File.createTempFile("test", "tmp");
@@ -62,6 +54,7 @@ public class PerfDiskIO implements ExamplePerfData {
     sink.close();
     b.mark("seqfile size", tmp.length());
     b.done();
+    mem = null; // allow mem to be freed.
 
     // //////// second phase using the file written in previous phase.
     Benchmark b2 = new Benchmark("seqfile_disk_read");
@@ -77,18 +70,4 @@ public class PerfDiskIO implements ExamplePerfData {
     b2.done();
   }
 
-  @Test
-  public void testReadFormat() throws IOException, InterruptedException {
-    Benchmark b = new Benchmark("log4j format read");
-    b.mark("begin");
-
-    Log4jTextFileSource txt = new Log4jTextFileSource(HADOOP_DATA[0]);
-    txt.open();
-    MemorySinkSource mem = new MemorySinkSource();
-    mem.open();
-    EventUtil.dumpAll(txt, mem);
-    txt.close();
-    b.mark("log4j_disk_loaded");
-    b.done();
-  }
 }
diff --git a/src/javaperf/com/cloudera/flume/PerfHdfsIO.java b/src/javaperf/com/cloudera/flume/PerfHdfsIO.java
index 4db1131..8097330 100644
--- a/src/javaperf/com/cloudera/flume/PerfHdfsIO.java
+++ b/src/javaperf/com/cloudera/flume/PerfHdfsIO.java
@@ -30,13 +30,12 @@ import com.cloudera.flume.conf.FlumeConfiguration;
 import com.cloudera.flume.core.Event;
 import com.cloudera.flume.core.EventUtil;
 import com.cloudera.flume.handlers.debug.MemorySinkSource;
-import com.cloudera.flume.handlers.debug.TextFileSource;
 import com.cloudera.flume.handlers.hdfs.SeqfileEventSink;
 import com.cloudera.flume.handlers.hdfs.WriteableEvent;
 import com.cloudera.flume.handlers.hdfs.WriteableEventKey;
 import com.cloudera.util.Benchmark;
 
-public class PerfHdfsIO implements ExamplePerfData {
+public class PerfHdfsIO {
 
   @Test
   public void testCopy() throws IOException, InterruptedException {
@@ -44,12 +43,7 @@ public class PerfHdfsIO implements ExamplePerfData {
     Benchmark b = new Benchmark("hdfs seqfile copy");
     b.mark("begin");
 
-    TextFileSource txt = new TextFileSource(HADOOP_DATA[0]);
-    txt.open();
-    MemorySinkSource mem = new MemorySinkSource();
-    mem.open();
-    EventUtil.dumpAll(txt, mem);
-    txt.close();
+    MemorySinkSource mem = FlumeBenchmarkHarness.synthInMem();
     b.mark("disk_loaded");
 
     File tmp = File.createTempFile("test", "tmp");
@@ -83,12 +77,7 @@ public class PerfHdfsIO implements ExamplePerfData {
     Benchmark b = new Benchmark("hdfs seqfile write");
     b.mark("begin");
 
-    TextFileSource txt = new TextFileSource(HADOOP_DATA[0]);
-    txt.open();
-    MemorySinkSource mem = new MemorySinkSource();
-    mem.open();
-    EventUtil.dumpAll(txt, mem);
-    txt.close();
+    MemorySinkSource mem = FlumeBenchmarkHarness.synthInMem();
     b.mark("disk_loaded");
 
     FlumeConfiguration conf = FlumeConfiguration.get();
